Index: TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/CAFilter.groovy
===================================================================
--- TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/CAFilter.groovy	(revision 0)
+++ TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/CAFilter.groovy	(revision 3555)
@@ -0,0 +1,301 @@
+// STANDARD DECLARATIONS
+package org.txm.macro.stats
+
+import org.kohsuke.args4j.*
+import groovy.transform.Field
+import org.txm.rcpapplication.swt.widget.parameters.*
+import org.txm.searchengine.cqp.clientExceptions.*
+import org.txm.searchengine.cqp.corpus.*
+import org.txm.searchengine.cqp.corpus.query.*
+import org.apache.commons.lang.time.StopWatch
+import java.util.Arrays
+import org.jfree.chart.renderer.xy.*
+import org.jfree.chart.renderer.*
+import org.jfree.chart.plot.*
+import org.jfree.data.xy.*
+import org.jfree.chart.axis.*
+import java.awt.*;
+import java.awt.geom.*;
+import org.jfree.chart.labels.*
+
+import org.txm.ca.core.chartsengine.jfreechart.themes.highcharts.renderers.*
+import org.txm.ca.rcp.editors.*
+import org.txm.libs.office.ReadODS
+import org.txm.ca.core.chartsengine.jfreechart.datasets.*
+import org.jfree.chart.renderer.AbstractRenderer
+
+import org.apache.commons.math3.stat.descriptive.*
+
+println "editor: "+editor
+
+if (!(editor instanceof CAEditor)) {
+	println "editor is not a CA editor: $editor, Run the macro with F12 when the editor is selected :-)"
+	return
+}
+
+def chartEditor = editor.getEditors()[0]
+def chartComposite = chartEditor.getComposite()
+
+// BEGINNING OF PARAMETERS
+
+// Declare each parameter here
+// (available widget types: Query, File, Folder, String, Text, Boolean, Integer, Float and Date)
+
+//@Field @Option(name="query", usage="an example query", widget="Query", required=true, def='[pos="V.*"]')
+//def query
+
+//@Field @Option(name="file", usage="an example file", widget="File", required=true, def="C:/Temp/foo.txt")
+//def file
+
+//@Field @Option(name="folder", usage="an example folder", widget="Folder", required=false, def="C:/Temp")
+//def folder
+
+//@Field @Option(name="date", usage="an example date", widget="Date", required=false, def="1984-09-01")
+//def date
+
+//@Field @Option(name="integer", usage="an example integer", widget="Integer", required=false, def="42")
+//def integer
+
+@Field @Option(name="QMin", usage="min Q", widget="Float", required=true, def="0.01")
+def QMin
+
+@Field @Option(name="CTRXMin", usage="min CTR X", widget="Float", required=true, def="0.001")
+def CTRXMin
+
+@Field @Option(name="CTRYMin", usage="min CTR Y", widget="Float", required=true, def="0.001")
+def CTRYMin
+
+@Field @Option(name="stackX", usage="stack X", widget="Float", required=true, def="0.0")
+def stackX
+
+@Field @Option(name="stackY", usage="stack Y", widget="Float", required=true, def="0.0")
+def stackY
+
+//@Field @Option(name="string", usage="an example string", widget="String", required=false, def="hello world!")
+//def string
+
+@Field @Option(name="regexFilter", usage="row property form regex", widget="Text", required=false, def="")
+def regexFilter
+
+@Field @Option(name="debug", usage="debug (verbose) mode", widget="Boolean", required=true, def="true")
+def debug
+
+// La fenêtre de résultats
+CAresultWindow = editor
+
+// Le tableau de données d'aide à l'interprétation
+// Les données de l'AFC sont manipulables par les méthodes documentées ici http://txm.sourceforge.net/javadoc/TXM/TBX/org/txm/stat/engine/r/function/CA.html
+
+ica = CAresultWindow.getCA()
+ca = ica.getCA()
+
+rowNames = ica.getRowNames()
+rowCos2 = ca.getRowCos2()
+rowContrib = ca.getRowContrib()
+
+colNames = ica.getColNames()
+colCos2 = ca.getColCos2()
+colContrib = ca.getColContrib()
+
+F1 = ica.getFirstDimension()-1
+F2 = ica.getSecondDimension()-1
+
+println sprintf("F1 = %d, F2 = %d, %d initial rows, %d initial cols", F1+1, F2+1, rowNames.length, colNames.length)
+
+def stats = { vector, factor ->
+	s = new DescriptiveStatistics()
+	(vector.length).times {
+		s.addValue(vector[it][factor]);
+	}
+
+	println "min       quartile  median    third quartile  max"
+	println sprintf("%8f  %8f  %8f  %8f        %8f", s.getMin(), s.getPercentile(25), s.getPercentile(50), s.getPercentile(75), s.getMax())
+}
+
+// rows
+
+println "ROWS -----"
+println "CTR"+(F1+1)
+stats(rowContrib, F1)
+
+println "CTR"+(F2+1)
+stats(rowContrib, F2)
+
+println "Cos² "+(F1+1)
+stats(rowCos2, F1)
+
+println "Cos² "+(F2+1)
+stats(rowCos2, F2)
+
+// cols
+
+println "COLS -----"
+println "CTR"+(F1+1)
+stats(colContrib, F1)
+
+println "CTR"+(F2+1)
+stats(colContrib, F2)
+
+println "Cos² "+(F1+1)
+stats(colCos2, F1)
+
+println "Cos² "+(F2+1)
+stats(colCos2, F2)
+
+
+def stats2 = { vector, factor1, factor2 ->
+	s = new DescriptiveStatistics()
+	(vector.length).times {
+		s.addValue(vector[it][factor1]+vector[it][factor2]);
+	}
+
+	println "min       quartile  median    third quartile  max"
+	println sprintf("%8f  %8f  %8f  %8f        %8f", s.getMin(), s.getPercentile(25), s.getPercentile(50), s.getPercentile(75), s.getMax())
+}
+
+println "Q"+(F1+1)+(F2+1)
+stats2(rowCos2, F1, F2)
+
+println "Q"+(F1+1)+(F2+1)
+stats2(colCos2, F1, F2)
+
+// Open the parameters input dialog box
+if (!ParametersDialog.open(this)) return
+
+// END OF PARAMETERS
+
+
+filteredRows = []
+
+println ""
+
+if (debug) println "\nROWS -----"
+
+if (regexFilter.length() > 0) {
+	nmatched = 0
+	rowNames.each { it ->
+		if (it ==~ regexFilter) {
+			if (debug && !filteredRows.contains(it)) {
+				if (nmatched > 0) print ", "
+				print it
+			}
+			filteredRows << it
+			nmatched++
+		}
+	}
+
+	if (debug && nmatched > 0) println ""
+
+	if (debug) {
+		println sprintf("\n%d rows filtered by regex", nmatched)
+	}
+
+}
+
+nQCTR = 0
+rowNames.eachWithIndex { it, i ->
+	def cos2 = rowCos2[i]
+	if ((rowContrib[i][F1] < CTRXMin) && (rowContrib[i][F2] < CTRYMin) && (cos2[F1] + cos2[F2] < QMin)) {
+		if (debug && !filteredRows.contains(rowNames[i])) {
+			if (nQCTR > 0) print ", "
+			print rowNames[i]
+		}
+		filteredRows << rowNames[i]
+		nQCTR++
+	}
+}
+
+if (debug) {
+	println sprintf("\n%d rows filtered by CTR or Q"+(F1+1)+(F2+1), nQCTR)
+}
+
+// cols
+
+filteredCols = []
+
+println ""
+
+if (debug) println "\nCOLS -----"
+
+if (regexFilter.length() > 0) {
+	nmatched = 0
+	colNames.each { it ->
+		if (it ==~ regexFilter) {
+			if (debug && !filteredCols.contains(it)) {
+				if (nmatched > 0) print ", "
+				print it
+			}
+			filteredCols << it
+			nmatched++
+		}
+	}
+
+	if (debug && nmatched > 0) println ""
+
+	if (debug) {
+		println sprintf("\n%d cols filtered by regex", nmatched)
+	}
+
+}
+
+nQCTR = 0
+colNames.eachWithIndex { it, i ->
+	def cos2 = colCos2[i]
+	if (!((colContrib[i][F1] > CTRXMin) || (colContrib[i][F2] > CTRYMin) || (cos2[F1] + cos2[F2] > QMin))) {
+		if (debug && !filteredCols.contains(colNames[i])) {
+			if (nQCTR > 0) print ", "
+			print colNames[i]
+		}
+		filteredCols << colNames[i]
+		nQCTR++
+	}
+}
+
+if (debug) {
+	println sprintf("\n%d cols filtered by CTR or Q"+(F1+1)+(F2+1), nQCTR)
+}
+
+double stackXv = stackX
+double stackYv = stackY
+
+
+// Visualisation graphique
+
+chartCAresultWindow = CAresultWindow.getEditors()[0]
+chartComposite = chartCAresultWindow.getComposite()
+
+monitor.syncExec( new Runnable() {
+	public void run() {
+
+				println chartComposite
+				def chart = chartEditor.getChart();
+
+				dataset2 = new CAXYDataset(ica)
+				
+				labels = dataset2.rowLabels
+				coords = dataset2.rowCoordinates
+				(labels.length).times {
+					if (filteredRows.contains(labels[it])) {
+						println "Moving "+labels[it]+" row to origin."
+						labels[it] = ""
+						coords[it][F1] = stackXv
+						coords[it][F2] = stackYv
+					}
+				}
+				labels = dataset2.columnLabels
+				coords = dataset2.columnCoordinates
+				(labels.length).times {
+					if (filteredCols.contains(labels[it])) {
+						println "Moving "+labels[it]+" col to origin."
+						labels[it] = ""
+						coords[it][F1] = stackXv
+						coords[it][F2] = stackYv
+					}
+				}
+
+				chart.getXYPlot().setDataset(dataset2)
+
+				ica.getChartCreator().getChartsEngine().getJFCTheme().apply(chart); // need to be call AFTER setRenderer() cause this method changes some renderering parameters
+				chartComposite.loadChart()
+			}
+})
Index: TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/InvertCAXAxisMacro.groovy
===================================================================
--- TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/InvertCAXAxisMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/InvertCAXAxisMacro.groovy	(revision 3555)
@@ -0,0 +1,125 @@
+// @author Sebastien Jacquot
+// STANDARD DECLARATIONS
+package org.txm.macro.stats
+
+
+import org.kohsuke.args4j.*
+import groovy.transform.Field
+import org.txm.rcpapplication.swt.widget.parameters.*
+import org.txm.searchengine.cqp.clientExceptions.*
+import org.txm.searchengine.cqp.corpus.*
+import org.txm.searchengine.cqp.corpus.query.*
+import org.apache.commons.lang.time.StopWatch
+import java.util.Arrays
+import org.jfree.chart.renderer.xy.*
+import org.jfree.chart.renderer.*
+import org.jfree.chart.plot.*
+import org.jfree.data.xy.*
+import org.jfree.chart.axis.*
+import java.awt.*;
+import java.awt.geom.*;
+import org.jfree.chart.labels.*
+
+import org.txm.ca.core.chartsengine.jfreechart.themes.highcharts.renderers.*
+import org.txm.ca.rcp.editors.*
+import org.txm.libs.office.ReadODS
+import org.txm.ca.core.chartsengine.jfreechart.datasets.*
+import org.jfree.chart.renderer.AbstractRenderer
+
+println "editor: "+editor
+
+if (!(editor instanceof CAEditor)) {
+	println "editor is not a CA editor: $editor, Run the macro with F12 when the editor is selected :-)"
+	return
+}
+
+ica = editor.getCA();
+chart = ica.getChart();
+plot = chart.getXYPlot();
+dataset = plot.getDataset(); 
+
+// overrides some dataset methods to return inverted X coordinates for columns and rows
+plot.setDataset(new CAXYDataset(ica) {
+
+        public Number getX(int series, int item) {
+                if(item == -1)        {
+                        System.out.println("CAXYDataset.getX()");
+                }
+                // Rows
+                if(series == 0) {
+                        return -this.rowCoordinates[item][this.axis1];
+                }
+                // Cols
+                else {
+                        return -this.columnCoordinates[item][this.axis1];
+                }
+        }
+        
+        
+         
+        /**
+         * Gets the minimum value in the specified series according to the specified axis.
+         * @param series
+         * @param axis
+         * @return
+         */
+        public double getMinValue(int series, int axis)        {
+                double minValue = 0;
+                double tmpMinValue;
+                double[][] coordinates = this.rowCoordinates;
+                if(series != 0)        {
+                        coordinates = this.columnCoordinates;
+                }
+                
+                for(int i = 0; i < coordinates.length; i++) {
+                        tmpMinValue = coordinates[i][axis];
+                        
+						// invert X coordinate
+                		if(axis == 0)        {
+                			tmpMinValue = -tmpMinValue;
+                		}
+                        
+                        if(tmpMinValue < minValue)        {
+                                minValue = tmpMinValue;
+                        }
+                }
+                
+                return minValue;
+        }
+        
+        /**
+         * Gets the maximum value in the specified series according to the specified axis.
+         * @param series
+         * @param axis
+         * @return
+         */
+        public double getMaxValue(int series, int axis)        {
+                double maxValue = 0;
+                double tmpMaxValue;
+                double[][] coordinates = this.rowCoordinates;
+                if(series != 0)        {
+                        coordinates = this.columnCoordinates;
+                }
+                
+                for(int i = 0; i < coordinates.length; i++) {
+                        tmpMaxValue = coordinates[i][axis];
+                        
+						// invert X coordinate
+                		if(axis == 0)        {
+                			tmpMaxValue = -tmpMaxValue;
+                		}
+                        
+                        if(tmpMaxValue > maxValue)        {
+                                maxValue = tmpMaxValue;
+                        }
+                }
+                
+                return maxValue;
+        }
+}
+);
+
+// update the limits dotted borders
+ica.getChartCreator().createCAFactorialMapChartLimitsBorder(chart);
+
+
Index: TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/rules.groovy
===================================================================
--- TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/rules.groovy	(revision 0)
+++ TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/rules.groovy	(revision 3555)
@@ -0,0 +1,228 @@
+// Functions
+
+def RedScale(n, min, max) {
+
+/* target for 4:
+40 40 255
+80 80 255
+120 120 255
+160 160 255
+
+RedScale(4, 40, 160)
+
+*/
+
+	delta = ((max-min)/(n-1)).round()
+		
+	colors = []
+
+	n.times {
+		v = min+delta*it
+		colors << "255 "+v+" "+v
+	}
+	
+	return colors
+}
+
+def GreenScale(n, min, max) {
+
+	delta = ((max-min)/(n-1)).round()
+		
+	colors = []
+
+	n.times {
+		v = min+delta*it
+		colors << v+" 255 "+v
+	}
+	
+	return colors
+}
+
+def BlueScale(n, min, max) {
+
+	delta = ((max-min)/(n-1)).round()
+		
+	colors = []
+
+	n.times {
+		v = min+delta*it
+		colors << v+" "+v+" 255"
+	}
+	
+	return colors
+}
+
+int_linear_min = { x, max_input, min_output, max_output ->
+
+	def y = x*(max_output-min_output)/max_input+min_output
+	
+	if (y < 1) {
+		return (int) min_output
+	} else {
+		return (int) y
+	}
+}
+
+def sex2Color(sexe) {
+	
+	switch(sexe) {
+		
+		case "F":
+			return "255 0 255"
+		case "M":
+			return "0 0 255"
+		default:
+			println "$sexe is not a sex value..."
+			return "0 0 0"
+	}
+}
+
+sex2Symbol = { sexe ->
+	
+	switch(sexe) {
+		
+		case "F":
+			return "⬤"
+		case "M":
+			return "✚"
+		default:
+			println "$sexe is not a sex value..."
+			return "?"
+	}
+}
+
+sex2Shape = { sexe ->
+	
+	switch(sexe) {
+		
+		case "F":
+			return "disk"
+		case "M":
+			return "triangle"
+		default:
+			println "$sexe is not a sex value..."
+			return "?"
+	}
+}
+
+sex2ColorScale = { sexe, scale ->
+	
+	switch(sexe) {
+		
+		case "F":
+			return blue_scale[scale]
+		case "M":
+			return red_scale[scale]
+		default:
+			println "$sexe is not a sex value..."
+			return "0 0 0"
+	}
+}
+
+colorScale = { color_scale, scale ->
+
+	try {
+    		value = color_scale[scale]
+    		if (value == null) {
+    			println "no scale $scale in $color_scale color_scale..."
+			return ""
+    		}
+	} catch ( IndexOutOfBoundsException e ) {
+    		println "no scale $scale in $color_scale color_scale..."
+		return ""
+	}
+	return value
+}
+
+parseInt = { str ->
+	if (str.isInteger()) {
+		return str.toInteger()
+	} else {
+		println "$str is not an Integer..."
+		return 0
+	}
+}
+
+parseFloat = { str ->
+
+	str = str.replaceAll(",", ".")
+	if (str.isFloat()) {
+		return str.toFloat()
+	} else {
+		println "$str is not a float number..."
+		return 0.0
+	}
+}
+
+// globals
+
+red_scale = RedScale(4, 40, 160)
+blue_scale = BlueScale(4, 40, 160)
+
+// https://www.schemecolor.com/solar-heat-color-scheme.php
+
+solarScale4 = [
+	"199 5 9",
+	"255 52 45",
+	"255 237 68",
+	"249 169 0"
+]
+
+mixedTxmPalette4 = [
+	"255 0 0",
+	"255 215 0",
+	"0 139 0",
+	"0 0 255"
+]
+
+rows_rules = // ajouter des [target, source]
+		[
+			// ["color",	"""c("autre")"""]
+			
+			// ...
+		]
+
+cols_rules = [
+
+/*
+
+Pattern :
+
+	[<column-name>, <groovy-code>]
+	
+	e.g. ["color", "1"]
+	
+	use " " for one space string
+
+- LABEL : cercle
+- TAILLE du label : fixe
+- COULEUR : fonction du sexe (couleur de base) et du quartile d'âge (dégradé)
+- POINT : pas de point
+
+LABEL : numéro du cercle
+TAILLE : fixe
+COULEUR : fonction du cercle. Prendre 4 couleurs qui suivent un ordre “naturel”, ex. Arc-en-ciel, ou chaud (cercle1) – froid (cercle 4), ex Rouge / Orange / Bleu / Violet. Ou bien un dégradé où l’on arrive bien à distinguer 4 valeurs (pas sûr que ce soit possible ?)
+TRANSPARENCE : filtrage éventuel sur cos2 
+
+c("cercle")
+c("age-quartile")
+sex2ColorScale(c("sexe"), c("age-quartile") as Integer)+" "+c(transparency)
+int_linear_min(c("q12") as Integer, 0.48, 80, 255)
+
+Examples:
+
+	["label-size", """1"""],
+	["label-replacement", """c("cercle")"""],
+	["transparency", """int_linear_min(parseFloat(c("cos2-1")), 0.43, 80, 255)"""],
+	["label-color", """sex2ColorScale(c("sexe"), parseInt(c("age-quartile")))+" "+c("transparency")"""],
+
+
+*/
+	["label-size", """1"""],
+	["label-replacement", """return(".")"""],
+	["shape-replacement", """sex2Shape(c("sexe"))"""],
+	["transparency", """int_linear_min(parseFloat(c("cos2-1")), 0.43, 80, 255)"""],
+	["shape-color", """colorScale(mixedTxmPalette4, parseInt(c("cercle"))-1)+" "+c("transparency")"""],
+	
+	// ajouter des [target, source] ici ...
+]
Index: TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/CaCompileStyleMacro.groovy
===================================================================
--- TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/CaCompileStyleMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/CaCompileStyleMacro.groovy	(revision 3555)
@@ -0,0 +1,217 @@
+// STANDARD DECLARATIONS
+// @author mdecorde sjacquot sheiden
+package org.txm.macro
+
+import org.kohsuke.args4j.*
+import groovy.transform.Field
+import org.txm.rcpapplication.swt.widget.parameters.*
+import org.txm.libs.office.ReadODS
+import org.txm.libs.office.WriteODS
+
+// ############################################
+
+
+c = { name ->
+	if (!style.containsKey(name)) {
+		println "No $name column..."
+		return false
+	}
+	return style[name]
+}
+
+def applyRules(def styles, def rules) {
+	for (def rule : rules) {
+		applyRule(styles, rule)
+	}
+}
+
+def applyRule(def styles, def rule) {
+	String pseudoCode = rule[1]
+//	if (pseudoCode.matches("[^(]+\\((.+)\\)")
+//	String method = 
+	//println "styles="+styles+" rule="+rule+ " "+styles[rule[0]]+" <- "+groovy.evaluate(rule[1])
+	styles[rule[0]] = groovy.evaluate(rule[1])	
+}
+
+// ############################################
+
+@Field @Option(name="rules_script", usage=".groovy file", widget="FileOpen", required=true, def='')
+def rules_script
+
+@Field @Option(name="functions_script", usage="functions used in rules, .groovy file", widget="FileOpen", required=true, def='')
+def functions_script
+
+@Field @Option(name="input_style_table", usage="must include 2 sheets named 'rows' and 'cols'", widget="FileOpen", required=true, def='')
+def input_style_table
+
+@Field @Option(name="output_style_table", usage="writes the 2 sheets rows and cols", widget="FileSave", required=true, def='')
+def output_style_table
+
+@Field @Option(name="debug", usage="Show internal variable content", widget="StringArray", metaVar="OFF	ON	ALL	REALLY ALL", required=true, def="OFF")
+debug
+
+// Open the parameters input dialog box
+if (!ParametersDialog.open(this)) return
+if (debug == "OFF") debug = 0 else if (debug == "ON") debug = 1 else if (debug == "ALL") debug = 2 else if (debug == "REALLY ALL") debug = 3
+
+if (!rules_script.exists()) {
+	println "Rules file not found: $rules_script. Aborting..."
+	return false
+}
+
+if (!functions_script.exists()) {
+	println "Functions file not found: $functions_script. Aborting..."
+	return false
+}
+
+groovy = new GroovyShell(binding)
+groovy.evaluate(functions_script.getText("UTF-8"))
+
+
+if (!input_style_table.exists()) {
+	println "Pattern file not found: $input_style_table"
+	return false
+}
+if (!input_style_table.isFile() || !input_style_table.getName().toLowerCase().endsWith(".ods")) {
+	println "Wrong pattern file: $input_style_table"
+	return false
+}
+
+cols_rules = null
+rows_rules = null
+
+groovy.evaluate(rules_script.getText("UTF-8"))
+//def rows_rules = []
+//rules_script.getLines("UTF-8") { line ->
+//	line = lilne.split("\t", 3)
+//	if ("row".equals(line[0])) {
+//		rows_rules << [line[1], line[2]]
+//	}
+//}
+//
+//def cols_rules = []
+//rules_script.getLines("UTF-8") { line ->
+//	line = lilne.split("\t", 3)
+//	if ("col".equals(line[0])) {
+//		cols_rules << [line[1], line[2]]
+//	}
+//}
+
+if (cols_rules == null) {
+	println "Error: no 'cols_rules' defined. Aborting..."
+	return false
+}
+
+if (rows_rules == null) {
+	println "Error: no 'rows_rules' defined. Aborting..."
+	return false
+}
+
+print "Reading input_style_table rows..."
+def data = ReadODS.toTable(input_style_table, "rows")  // read from the "rows" sheet
+println "Done."
+
+print "Applying rows styles..."
+
+def keys = data[0]
+def row_styles = [] // reformat data
+	for (int i = 1 ; i < data.size() ; i++) {
+		def h = data[i]
+		style = [:] // create style entry
+		
+		// fill the style
+		for (int j = 0 ; j < h.size() ; j++) {
+			style[keys[j]] = h[j]
+		}
+		
+		applyRules(style, rows_rules)
+		row_styles << style
+	}
+if (debug > 0) {
+	println "ROW STYLES="+row_styles.join("\n")
+}
+println "Done."
+
+print "Reading input_style_table cols..."
+data = ReadODS.toTable(input_style_table, "cols") // read from the "cols" sheet
+println "Done."
+
+print "Applying cols styles..."
+
+keys = data[0]
+def col_styles = [] // reformat data
+
+for (int i = 1 ; i < data.size() ; i++) {
+	def h = data[i]
+	style = [:] // create style entry
+	
+	// fill the style
+	for (int j = 0 ; j < h.size() ; j++) {
+		style[keys[j]] = h[j]
+	}
+	
+	applyRules(style, cols_rules)
+	col_styles << style
+}
+if (debug > 0) {
+	println "COL STYLES="+col_styles.join("\n")
+}
+println "Done."
+
+print "Writing output_style_table..."
+WriteODS writer = new WriteODS(output_style_table)
+writer.table.setTableName("rows")
+if (row_styles.size() > 0) {
+
+	print "Writing rows styles..."
+	
+	writer.declareRowsAndColumns(row_styles.size(), row_styles[0].size())
+	keys = row_styles[0].keySet()
+	try {
+		writer.writeLine(keys as ArrayList, 0)
+	} catch(e) {
+		println "** Error in writer.writeLine(keys as ArrayList, 0)"
+		e.printStackTrace()
+	}
+	int iRow = 1
+	for (def style : row_styles) {
+		def line = []
+		for (def k : keys) line << style[k]
+			try {
+				writer.writeLine(line, iRow++)
+			} catch(e) {
+				println "** Error in writer.writeLine('$line', '${iRow+1}')"
+				e.printStackTrace()
+			}
+	}
+}
+
+table = writer.newTable("cols")
+if (col_styles.size() > 0) {
+
+	print "Writing cols styles..."
+	
+	writer.declareRowsAndColumns(col_styles.size(), col_styles[0].size())
+	
+	keys = col_styles[0].keySet()
+	try {
+		writer.writeLine(keys as ArrayList, 0)
+	} catch(e) {
+		println "** Error in writer.writeLine(keys as ArrayList, 0)"
+		e.printStackTrace()
+	}
+	int iRow = 1
+	for (def style : col_styles) {
+		def line = []
+		for (def k : keys) line << style[k]
+			try {
+				writer.writeLine(line, iRow++)
+			} catch(e) {
+				println "** Error in writer.writeLine('$line', '${iRow+1}')"
+				e.printStackTrace()
+			}
+	}
+}
+println "Done."
+
+writer.save()
Index: TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/PlotEllipsesMacro.groovy
===================================================================
--- TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/PlotEllipsesMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/stats/PlotEllipsesMacro.groovy	(revision 3555)
@@ -0,0 +1,36 @@
+// STANDARD DECLARATIONS
+package org.txm.macro.stats
+
+import org.txm.ca.core.functions.CA
+import org.txm.statsengine.r.core.RWorkspace
+import groovy.transform.Field
+// BEGINNING OF PARAMETERS
+
+if (!(corpusViewSelection instanceof CA)) {
+	println "Selection is not a CA. Please select a CA result in the Corpus view"
+	return;
+}
+
+def ca = corpusViewSelection
+
+@Field @Option(name="outputFile", usage="an example file", widget="FileSave", required=true, def="file.svg")
+def outputFile
+
+@Field @Option(name="draw", usage="'row' or 'col'", widget="String", required=true, def="row")
+def draw
+// Open the parameters input dialog box
+if (!ParametersDialog.open(this)) return;
+
+// END OF PARAMETERS
+
+def s = ca.getRSymbol()
+def RW = RWorkspace.getRWorkspaceInstance()
+
+def script = """
+plot($s);
+ellipseCA($s, ellipse=c("$draw"));
+"""
+
+RW.plot(outputFile, script);
+
+println "Done: "+outputFile.getAbsolutePath()
\ No newline at end of file
Index: TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/utils/ListFontsMacro.groovy
===================================================================
--- TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/utils/ListFontsMacro.groovy	(revision 0)
+++ TXM/trunk/org.txm.groovy.core/src/groovy/org/txm/macro/utils/ListFontsMacro.groovy	(revision 3555)
@@ -0,0 +1,16 @@
+// Copyright © 2019 ENS de Lyon, CNRS, University of Franche-Comté
+// Licensed under the terms of the GNU General Public License (http://www.gnu.org/licenses)
+// @author mdecorde
+// @author sheiden
+// STANDARD DECLARATIONS
+package org.txm.macro.utils
+
+def e = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment()
+def fonts = e.getAllFonts()
+
+println fonts.size()+" fonts on this computer:"
+println ""
+
+fonts.each { f ->
+	println f.getFontName()
+}
Index: TXM/trunk/org.txm.treesearch.rcp/src/org/txm/treesearch/command/SendToTreeSearch.java
===================================================================
--- TXM/trunk/org.txm.treesearch.rcp/src/org/txm/treesearch/command/SendToTreeSearch.java	(revision 0)
+++ TXM/trunk/org.txm.treesearch.rcp/src/org/txm/treesearch/command/SendToTreeSearch.java	(revision 3555)
@@ -0,0 +1,170 @@
+// Copyright © 2010-2020 ENS de Lyon., University of Franche-Comté
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+// 
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+// 
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+// 
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+// 
+// 
+// 
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$ 
+//
+package org.txm.treesearch.command;
+
+import java.util.List;
+
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.StructuredSelection;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.concordance.core.functions.Concordance;
+import org.txm.concordance.core.functions.Line;
+import org.txm.concordance.rcp.editors.ConcordanceEditor;
+import org.txm.core.results.TXMResult;
+import org.txm.edition.rcp.editors.SynopticEditionEditor;
+import org.txm.objects.Match;
+import org.txm.rcp.editors.ITXMResultEditor;
+import org.txm.rcp.handlers.BaseAbstractHandler;
+import org.txm.rcp.utils.SWTEditorsUtils;
+import org.txm.searchengine.core.Selection;
+import org.txm.treesearch.editor.TreeSearchEditor;
+import org.txm.treesearch.function.TreeSearch;
+import org.txm.treesearch.rcp.Messages;
+import org.txm.utils.logger.Log;
+
+
+/**
+ * Open the TIGERSearch Editor using the current selection OR a preference node set in the RCP command parameter TXMPreferences.RESULT_PARAMETERS_NODE_PATH
+ * 
+ * @author mdecorde
+ */
+public class SendToTreeSearch extends BaseAbstractHandler {
+	
+	/** The ID. */
+	public static String ID = SendToTreeSearch.class.getName();
+	
+	/*
+	 * (non-Javadoc)
+	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
+	 */
+	@Override
+	public Object execute(final ExecutionEvent event) throws ExecutionException {
+		
+		ITXMResultEditor<? extends TXMResult> editor = SWTEditorsUtils.getActiveEditor(event);
+		
+		ISelection s = HandlerUtil.getCurrentSelection(event);
+		
+		if (editor instanceof ConcordanceEditor) {
+			return concordancetoTree(editor, s);
+		} else if (editor instanceof SynopticEditionEditor) {
+			return editiontoTree(editor, s);
+		} else {
+			return null;
+		}
+	}
+	
+	public Object editiontoTree(ITXMResultEditor<? extends TXMResult> editor, ISelection s) {
+		System.out.println("Send EDITION TO TREE");
+		return null;
+	}
+	
+	public Object concordancetoTree(ITXMResultEditor<? extends TXMResult> editor, ISelection s) {
+		TXMResult r = editor.getResult();
+		
+		if (!(r instanceof Concordance)) {
+			Log.warning(Messages.bind(Messages.ResultIsNotAConcordanceP0, r));
+			return null;
+		}
+		
+		if (!(s instanceof StructuredSelection)) {
+			Log.warning(Messages.bind(Messages.SelectionIsNotALineP0, s));
+			return null;
+		}
+		
+		StructuredSelection selection = (StructuredSelection) s;
+		List list = selection.toList();
+		
+		if (list.size() == 0) {
+			Log.warning(Messages.bind(Messages.NoEditorSelectionP0, r));
+			return null;
+		}
+		
+		Concordance concordance = (Concordance)r;
+		Object o = list.get(0);
+		if (!(o instanceof Line)) {
+			Log.warning(Messages.bind(Messages.SelectionIsNotALineP0, o));
+			return null;
+		}
+		Line l = (Line)o;
+		//TreeSearchSelector selector = ComputeTreeSearch.getSelectorForCorpus(concordance.getCorpus(), "UD");
+		
+		TreeSearchEditor leditor = editor.getLinkedEditor(TreeSearchEditor.class);
+		TreeSearch ts = null;
+		if (leditor != null) {
+			ts = leditor.getResult();
+			ts.setQuery(null);
+		} else {
+			ts = ComputeTreeSearch.getTreeSearchFor(concordance.getCorpus());
+			ts.setQuery(null);
+		}
+		//ts.setQuery(concordance.getQuery());
+		
+		try {
+			boolean c = ts.compute();
+			Selection sel = ts.getSelection();
+			int kp = l.getKeywordPosition();
+//			System.out.println("KP="+kp);
+			if (c &&  sel != null) {
+				int i = 0;
+				List<? extends Match> matches = ts.getSelection().getMatches();
+				
+				for (Match m : matches) {
+					if (m.getStart() <= kp && kp <= m.getEnd()) {
+//						System.out.println("set index "+(i+1));
+						ts.setIndexAndSubIndex(i+1, 1);
+						break;
+					}
+					i++;
+				}
+			}
+		}
+		catch (Exception e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		
+		if (leditor == null) {
+			ITXMResultEditor<TXMResult> openedEditor = ComputeTreeSearch.openEditor(ts);
+			if (openedEditor != null) {
+				editor.addLinkedEditor(openedEditor);
+			}
+			return openedEditor;
+		} else {
+			try {
+				leditor.refresh(true);
+			}
+			catch (Exception e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+		return leditor;
+	}
+}

